Lollipop Chart in JavaScript

Using ApexCharts with JavaScript

This Lollipop Chart example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Marks (#11): a lollipop is a scalar-y series (the default dataType), so no
// range routing is needed. renderItem draws a stem from the baseline up to the
// value, capped with a circle. Each mark is tagged with its datum identity, so
// the shared tooltip, legend toggle and dataPointSelection all work for free.
ApexCharts.registerSeriesType('lollipop', {
  renderItem: function (ctx) {
    var x = ctx.x
    var y = ctx.y
    var scales = ctx.scales
    var api = ctx.api
    var color = ctx.color
    var baseline = scales.y(0)
    api.line({ x1: x, y1: baseline, x2: x, y2: y, stroke: color, width: 2 })
    api.circle({ cx: x, cy: y, r: 6, fill: color })
  },
})

var lollipopData = [
  { x: 'Jan', y: 41 },
  { x: 'Feb', y: 58 },
  { x: 'Mar', y: 45 },
  { x: 'Apr', y: 72 },
  { x: 'May', y: 68 },
  { x: 'Jun', y: 91 },
  { x: 'Jul', y: 84 },
  { x: 'Aug', y: 63 },
  { x: 'Sep', y: 49 },
  { x: 'Oct', y: 77 },
  { x: 'Nov', y: 88 },
  { x: 'Dec', y: 102 },
]

var options = {
  series: [{ name: 'Signups', data: lollipopData }],
  chart: {
    height: 440,
    type: 'lollipop',
    animations: { enabled: false },
    toolbar: { show: false },
  },
  colors: ['#775DD0'],
  grid: {
    padding: { left: 12, right: 12 },
  },
  title: {
    text: 'Monthly active signups',
    align: 'left',
  },
  subtitle: {
    text: 'A custom "lollipop" series type built with Marks (registerSeriesType)',
    align: 'left',
  },
  xaxis: {
    type: 'category',
    tooltip: { enabled: false },
  },
  yaxis: {
    min: 0,
    max: 120,
    tickAmount: 6,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Lollipop Chart in React

Using ApexCharts with React

This Lollipop Chart example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// Marks (#11): a lollipop is a scalar-y series (the default dataType), so no
// range routing is needed. renderItem draws a stem from the baseline up to the
// value, capped with a circle. Each mark is tagged with its datum identity, so
// the shared tooltip, legend toggle and dataPointSelection all work for free.
ApexCharts.registerSeriesType('lollipop', {
  renderItem: function (ctx) {
    var x = ctx.x
    var y = ctx.y
    var scales = ctx.scales
    var api = ctx.api
    var color = ctx.color
    var baseline = scales.y(0)
    api.line({ x1: x, y1: baseline, x2: x, y2: y, stroke: color, width: 2 })
    api.circle({ cx: x, cy: y, r: 6, fill: color })
  },
})

var lollipopData = [
  { x: 'Jan', y: 41 },
  { x: 'Feb', y: 58 },
  { x: 'Mar', y: 45 },
  { x: 'Apr', y: 72 },
  { x: 'May', y: 68 },
  { x: 'Jun', y: 91 },
  { x: 'Jul', y: 84 },
  { x: 'Aug', y: 63 },
  { x: 'Sep', y: 49 },
  { x: 'Oct', y: 77 },
  { x: 'Nov', y: 88 },
  { x: 'Dec', y: 102 },
]

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [{ name: 'Signups', data: lollipopData }],
    options: {
      chart: {
        height: 440,
        type: 'lollipop',
        animations: { enabled: false },
        toolbar: { show: false },
      },
      colors: ['#775DD0'],
      grid: {
        padding: { left: 12, right: 12 },
      },
      title: {
        text: 'Monthly active signups',
        align: 'left',
      },
      subtitle: {
        text: 'A custom "lollipop" series type built with Marks (registerSeriesType)',
        align: 'left',
      },
      xaxis: {
        type: 'category',
        tooltip: { enabled: false },
      },
      yaxis: {
        min: 0,
        max: 120,
        tickAmount: 6,
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="lollipop"
          height={440}
        />
      </div>

      <div className="panel">
        <div className="note">
          A lollipop is a scalar-y custom series: <code>renderItem</code> draws
          a stem from <code>scales.y(0)</code> up to the value and caps it with
          a circle. Marks carry their datum identity, so hover, the shared
          tooltip and legend toggle work without any extra wiring.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Lollipop Chart in Vue

Using ApexCharts with Vue

This Lollipop Chart example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="lollipop"
        height="440"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>

    <div class="panel">
      <div class="note">
        A lollipop is a scalar-y custom series: <code>renderItem</code> draws a
        stem from <code>scales.y(0)</code> up to the value and caps it with a
        circle. Marks carry their datum identity, so hover, the shared tooltip
        and legend toggle work without any extra wiring.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// Marks (#11): a lollipop is a scalar-y series (the default dataType), so no
// range routing is needed. renderItem draws a stem from the baseline up to the
// value, capped with a circle. Each mark is tagged with its datum identity, so
// the shared tooltip, legend toggle and dataPointSelection all work for free.
ApexCharts.registerSeriesType('lollipop', {
  renderItem: function (ctx) {
    var x = ctx.x
    var y = ctx.y
    var scales = ctx.scales
    var api = ctx.api
    var color = ctx.color
    var baseline = scales.y(0)
    api.line({ x1: x, y1: baseline, x2: x, y2: y, stroke: color, width: 2 })
    api.circle({ cx: x, cy: y, r: 6, fill: color })
  },
})

var lollipopData = [
  { x: 'Jan', y: 41 },
  { x: 'Feb', y: 58 },
  { x: 'Mar', y: 45 },
  { x: 'Apr', y: 72 },
  { x: 'May', y: 68 },
  { x: 'Jun', y: 91 },
  { x: 'Jul', y: 84 },
  { x: 'Aug', y: 63 },
  { x: 'Sep', y: 49 },
  { x: 'Oct', y: 77 },
  { x: 'Nov', y: 88 },
  { x: 'Dec', y: 102 },
]

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [{ name: 'Signups', data: lollipopData }],
      chartOptions: {
        chart: {
          height: 440,
          type: 'lollipop',
          animations: { enabled: false },
          toolbar: { show: false },
        },
        colors: ['#775DD0'],
        grid: {
          padding: { left: 12, right: 12 },
        },
        title: {
          text: 'Monthly active signups',
          align: 'left',
        },
        subtitle: {
          text: 'A custom "lollipop" series type built with Marks (registerSeriesType)',
          align: 'left',
        },
        xaxis: {
          type: 'category',
          tooltip: { enabled: false },
        },
        yaxis: {
          min: 0,
          max: 120,
          tickAmount: 6,
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 780px;
  margin: 20px auto;
}
.panel {
  max-width: 780px;
  margin: 16px auto;
  font-family: sans-serif;
}
.note {
  background: #f4fbf6;
  border-left: 3px solid #00b894;
  padding: 10px 14px;
  font-size: 13px;
  color: #234;
  border-radius: 2px;
  line-height: 1.55;
}
.note code {
  background: #dff3e8;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Lollipop Chart in Angular

Using ApexCharts with Angular

This Lollipop Chart example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private lollipopData: any = [
          { x: 'Jan', y: 41 },
          { x: 'Feb', y: 58 },
          { x: 'Mar', y: 45 },
          { x: 'Apr', y: 72 },
          { x: 'May', y: 68 },
          { x: 'Jun', y: 91 },
          { x: 'Jul', y: 84 },
          { x: 'Aug', y: 63 },
          { x: 'Sep', y: 49 },
          { x: 'Oct', y: 77 },
          { x: 'Nov', y: 88 },
          { x: 'Dec', y: 102 },
        ];

  public chartOptions: Partial<ChartOptions> = {
          series: [{ name: 'Signups', data: this.lollipopData }],
          chart: {
            height: 440,
            type: 'lollipop',
            animations: { enabled: false },
            toolbar: { show: false },
          },
          colors: ['#775DD0'],
          grid: {
            padding: { left: 12, right: 12 },
          },
          title: {
            text: 'Monthly active signups',
            align: 'left',
          },
          subtitle: {
            text: 'A custom "lollipop" series type built with Marks (registerSeriesType)',
            align: 'left',
          },
          xaxis: {
            type: 'category',
            tooltip: { enabled: false },
          },
          yaxis: {
            min: 0,
            max: 120,
            tickAmount: 6,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    ApexCharts.registerSeriesType('lollipop', {
            renderItem: (ctx) => {
              var x = ctx.x
              var y = ctx.y
              var scales = ctx.scales
              var api = ctx.api
              var color = ctx.color
              var baseline = scales.y(0)
              api.line({ x1: x, y1: baseline, x2: x, y2: y, stroke: color, width: 2 })
              api.circle({ cx: x, cy: y, r: 6, fill: color })
            },
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}